# by plushpuffin@wwddfd.com
# http://www.wwddfd.com
# Loki: The ndisplay.pl editor
#

&CheckBuild(28, "Loki", "npa_loki.pl");
push(@Addons_Loaded, 'Loki 1.0');
push(@Addons_PageHandler, 'Loki_PageHandler');
push(@Addons_MainPage, 'Loki_MainPage');
push(@Addons_NPHTMLFoot, 'Loki_HTMLFoot');
$Addons_List{'Loki 1.0'} = ['npa_loki.pl', 'ndisplay editor. by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a>'];

sub Loki_EditNewsDisplay {
	unless ($up == 3) {
		&NPdie("You are not authorized to edit this.");
	}
	my( @ffields, $ndisp, $ndisplay, $ndcontent, $ManualEdit );
	if ($abspath ne '') {
		NPopen('NPC', "$abspath/ndisplay.pl");
	}
	else {
		NPopen('NPC', "ndisplay.pl");
	}
	{ local $/; $ndisplay = <NPC>; }
	close( NPC );
	&SubmitFormFields;
	&loadND;
	@ffields = ( @formfields, @ffield_add );
	@ffields = sort @ffields;
	unless ($ndisplay =~ /<ManualEdit>/) {
		$ndisplay =~ /<BeginEdit>(.*)\n(.*)\n([\s\S]+)\n(.*)\n(.*)<EndEdit>/;
		$ndcontent = $3;
		$ndcontent =~ s/^\s+//;
		$ndcontent =~ s/\s+$//;
		$ndcontent = HTMLescape($ndcontent);
		$ndisp = $ndcontent;
		foreach (@ffields) {
			$ndisp =~ s/\$$_(\W)/&lt;%$_%&gt;$1/gi;
		}
		$ndisp =~ s/\\\$/\$/g;
		$ndisp =~ s/\\\@/\@/g;
	}
	else {
		$ManualEdit = 1;
		&NPHTMLHead("Can't Edit News Display");
		print qq~<b>You have edited ndisplay.pl manually. You can no longer edit it via the web.</b>~;
		&NPHTMLFoot;
		exit;
	}

	&NPHTMLHead("Edit News Display");
	print qq~
<form action="$scripturl?lokisave" method=post>
<p align="left">Below, you will be able to edit the HTML used to display your news. 
</p>
<p align="left">Use the following &quot;tags&quot; to include your news information:
<hr width="50%"><br><b>
<table width="90%" align="center"><tr>
~;
	my $fn = 0;
	while( $fn < @ffields ) {
		print qq~<td><strong><div align="center">&lt;%$ffields[$fn]%&gt;</div></strong></td>~;
		$fn++;
		unless( $fn % 3 ) { print "</tr><tr>"; }
	}
	if( $fn % 3 ) { print "</tr>"; }
	print qq~</table></b></p><hr width="50%"><p align="center">
<textarea name="ndisplay" cols="80" rows="10" wrap="VIRTUAL" style="width:100%;">$ndisp</textarea></p>
<p align="center"><input type="submit" name="Submit" value="Save Display"></p>
<p align="center">Note: For a higher degree of customization you must edit text 
files. These include archive.tmpl (the template used to create your archives),
arclink.tmpl (the template used to create the links page to your monthly archives),
and ndisplay.pl(contains the HTML used to generate news and links).
For more information, see the <a href="http://amphibian.gagames.com/newspro/faq2/">NewsPro FAQ</a>.</p>
</form>
~;
	&Loki_DisplayDemo;
	&NPHTMLFoot;
	exit;
}

sub Loki_DisplayDemo {
	if( @NewsData ) {
		$ArcHtmlExt = $NPConfig{'ArcHtmlExt'};
		require $ndisplaypl;
		$currenttime = time;
		&getNDvar(0);
		&DoNewsHTML;
		if ($NPConfig{'CreateAnchors'}) {print NEWSHTML qq~<a name="newsitem$newsid"></a>~;}
		print qq~<br><br>
		<center><strong>Loki Halfhearted Display Demo</strong></center>
		<table width="95%" bgcolor="#ffffff" border="5" align="center"><tr><td>
		$newshtml
		</td></tr></table><br><br>
		~;
	}
}

sub Loki_SaveNewsDisplay {
	unless ($up == 3) {
		NPdie("You are not authorized to edit this");
	}
	&SubmitFormFields;
	&loadND;
	my @ffields = ( @formfields, @ffield_add );
	if( $in{'ndisplay'} ) {
		$in{'ndisplay'} =~ s/\r//g;
		$in{'ndisplay'} =~ s/\$/\\\$/g;
		$in{'ndisplay'} =~ s/\@/\\\@/g;
		$in{'ndisplay'} =~ s/~/\%2E/g;
		foreach (@ffields) {
			$in{'ndisplay'} =~ s/<%($_)%>/\$$1/gi;
		}
	}
	if ($in{'ndisplay'}) {
		NPopen('NDS', "$NPConfig{'admin_path'}/ndisplay.pl");
		{ local $/; $nds = <NDS>; }
		close(NDS);
		if ($nds =~ /<ManualEdit>/) {
			&NPHTMLHead("Display Not Saved");
			print qq~For some reason you must have modified your ndisplay.pl before submitting this page. I don't know why you would do this, but I included this check just in case.~;
			&NPHTMLFoot;	
			exit;
		}
		else {
			$nds =~ /^([\s\S]+)<BeginEdit>([\s\S]+)<EndEdit>([\s\S]+)/;
			if ($abspath ne '') {
				NPopen('NPC', ">$abspath/ndisplay.pl");
			}
			else {
				NPopen('NPC', ">ndisplay.pl");
			}
			print NPC "$1<BeginEdit>\n";
			print NPC "\$newshtml = qq~\n";
			print NPC $in{'ndisplay'};
			print NPC "\n~;\n";
			print NPC "# DO NOT REMOVE THIS LINE! <EndEdit>$3";
			close(NPC);
		}
	}
	&NPHTMLHead("Loki Display Saved");
	print qq~<h3>Your News Display have been saved. You must <a href="$scripturl?generate">build news</a> before these changes will take effect on your news pages.</h3>~;
	&Loki_DisplayDemo;
	&NPHTMLFoot;
	exit;
}

sub Loki_PageHandler {
	if (query_string() eq 'loki') {
		&Loki_EditNewsDisplay;
	}
	elsif(query_string() eq 'lokisave') {
		&Loki_SaveNewsDisplay;
	}
}

sub Loki_HTMLFoot {
	if ($up == 3) {
		print qq~ <a href="$scripturl?loki" class="navlink">Loki</a> |~;
	}
}

sub Loki_MainPage {
	if ($up == 3) {
		print qq~
		<b><a href="$scripturl?loki">Loki</a>:</b> Edit ndisplay web-like, grok?. (I don't know, you naughty boy! I've never grokked!)<br><br>
		~;
	}
}
1;
